Fifty1 Software Maya-to-OGRE |

Links

Fifty1 Home
Fifty1 OGRE Stuff
OGRE Home

(Developed with macross from bytelords.de)

Contents

> Downloads
> Installation
> Usage
> Known Bugs and Limitations
> Features

Downloads

- Source code is part of OGRE (0.12.1 and above)
- Pre-compiled exporters:
  - Ogre 0.12 and older:
    - Windows Maya 4.5 (2003-10-31)
    - Windows Maya 5.0 (2003-10-31)
  - Ogre 0.13 and newer
    - Windows Maya 4.5 (2004-01-07)
    - Windows Maya 5.0 (2004-01-04)
- Maya MEL scripts (Windows .zip archive) (2003-10-15)
- Pre-compiled OgreXMLConverter and support DLLs (Windows .zip archive) (2003-10-23)

> Back to Top

Installation

Installation instructions assume you are using the pre-compiled files above.

1. Copy the following MEL scripts to your Maya scripts directory (typically "My Documents/Maya/4.5/scripts" or "My Documents/Maya/5.0/scripts" in Windows):
   - maya2ogre_setup.mel
   - maya2ogre_window.mel
   - maya2ogre_export.mel
2. Update userSetup.mel file in Maya scripts directory with contents of userSetup.mel for Maya exporter
   - If userSetup.mel does not exist in your scripts directory, copy it there
   - If userSetup.mel exists in your script directory, append the contents of the new userSetup.mel to the end (using Notepad)
3. Copy the appropriate (Maya 4.5 or Maya 5.0) pre-compiled command-line exporter to a location in your path
   - Alternatively, copy to Maya scripts directory to use from Maya UI only (will not be available from command-line)
4. Copy the pre-compiled OgreXMLConverter and support DLLs to a location in your path
   - Required support DLLs are OgreMain.dll, devil.dll and ilu.dll
   - Alternatively, copy to Maya scripts directory to use from Maya UI only (will not be available from command-line)

   Back to Top

Usage

- Maya usage:
  - Launch exporter UI from new 'Ogre' menu (Ogre | Export)
  - Define export details
    - Should be self-explanatory
    - Export details are saved with the Maya file after each export
- Command-line usage:

      Version : Oct 15 2003 11:47:30
      Maya API: 450

      Usage: maya2ogre -in FILE [-mesh [FILE]] [-vba] [-skel [FILE]]
                       [-anim NAME START END STEP]
                       [-mat [FILE]] [-mprefix PREFIX]
                       [-n] [-c] [-t] [-v]

       -in      FILE   input mb File
       -mesh    FILE   export mesh (FILE is optional)
       -vba            export vertex bone assignments
       -skel    FILE   export skeleton (FILE is optional)
       -anim    NAME   export Animation beginning at START and ending
                START  at END with fixed STEP
                END
                STEP
       -mat     FILE   export material (FILE is optional)
       -mprefix PREFIX material prefix
       -n              export normals
       -c              export diffuse colours
       -t              export texture coords
       -v              more output

      Examples:
       maya2ogre -in foo.mb -mesh -skel -mat
           => exports skeleton, mesh and material using default file names,
              in this case foo.mesh.xml, foo.skeleton.xml and foo.material

       maya2ogre -in foo.mb -mesh custom_name.mesh.xml -skel custom_name.skel.xml
           => exports skeleton and mesh using user defined file names

       maya2ogre -in foo.mb -skel -anim Walk 1 30 2 -anim Die 50 60 2
           => exports skeleton with animation tracks Walk and Die

> Back to Top

Known Bugs and Limitations

1. Skeleton supports only one skin cluster per mesh
   - All vertices in mesh must be connected to skin cluster
2. MEL scripts call command-line tool instead of a native Maya plug-in
3. MEL scripts do not work on Linux or Irix
   - Small additions required -- anyone willing to help?
4. Exporter assigns the default material (lambert1) if the initialShadingGroup is connected to a Maya Mesh directly or indirectly.
   - Workaround is to remove all extra connections to the initialShadingGroup using Hypershade
   - When creating Maya models as you are skinning the mesh to the joints you have the option of smooth binding or rigid binding. We have found that with rigid binding you don't get any bone assignments, but when the using smooth binding the exporter works perfectly fine.

Back to Top

Features

> Mesh Export

> - Exports everything related to a mesh
>   - Vertices
>   - Normals
>   - Vertex colours
>   - Texture coordinates (all sets)
>   - Bone assignments and weights
>   - Include/exclude any of the above
> - Vertex optimization removes duplicate vertices before exporting
>   - Based on position, normal, colour, uvs
> - Defaults to XML
>   - Convert to binary with OgreXMLConverter
>   - Maya UI can automatically launch binary conversion

> Material Export

> - Colours (ambient, diffuse, specular, emissive)
> - Shininess for specular colours (requires calibration)
> - Texture names

> Skeleton/Animation Export

> - Vertex bone assignments and weights
> - Multiple named animations
>   - Animation name
>   - Start frame
>   - End frame
>   - Number of frames to skip
> - Up to 8 named animations preserved in Maya UI
> - Default to XML
>   - Convert to binary with OgreXMLConverter
>   - Maya UI can automatically launch binary conversion

> Back to Top

Contents copyright ©2003 Fifty1 Software Inc. Granite is a registered trademark of Fifty1 Software Inc.